!*****************************************************************
!*                       PINOCCHI0  V3.0                         *
!*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
!*****************************************************************
!
!This code was written by
!Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
!Copyright (C) 2013
!
!web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
!
!This program is free software; you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation; either version 2 of the License, or
!(at your option) any later version.
!
!This program is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with this program; if not, write to the Free Software
!Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



module fragment_grids
  use numbers
  integer(kind=singleI)::ngroups_tot
end module fragment_grids

module fragment_link
  use numbers
  integer(kind=singleI),allocatable,dimension(:)::group_ID,link_list,point,bottom
  integer(kind=singleI)::sizeof_groupID=4,sizeof_linklist=4
end module fragment_link

module fragment_merger
  use numbers
  integer(kind=singleI),parameter::MASSMIN=10
  integer(kind=singleI),allocatable,dimension(:)::GR_LL,HALO_APP & !MCENTR,
       ,MASS_AT_MERGER,MERGED_WITH
  real(kind=doubleR),allocatable,dimension(:)::MAJORZ,T_ACC,T_APPEAR
end module fragment_merger

module fragment_group_vectors
  use numbers
  integer(kind=singleI)::ngroups
  integer(kind=singleI),allocatable,dimension(:)::mass
  integer(kind=doubleI),allocatable,dimension(:)::name
  logical,allocatable,dimension(:)::good
  real(kind=doubleR),allocatable,dimension(:,:)::centres,velgrp
#ifdef PLC
  real(kind=doubleR),allocatable,dimension(:)::Flast
  real(kind=doubleR),dimension(3)::PLCone_centre
  integer(kind=singleI)::sizeof_groups=88
  integer(kind=doubleI),allocatable,dimension(:)::nameplc
  real(kind=doubleR),allocatable,dimension(:,:)::xplc,vplc
  real(kind=doubleR),allocatable,dimension(:)::zplc,Mplc
#else
  integer(kind=singleI)::sizeof_groups=80
#endif

end module fragment_group_vectors

module fragment_matrices
  use numbers
  real(kind=doubleR),allocatable,dimension(:)::Fmax_frag,vx,vy,vz
  integer(kind=singleI),allocatable,dimension(:)::indices
  integer(kind=singleI)::sizeof_frag=8
  integer(kind=singleI)::sizeof_indices=4
end module fragment_matrices

module fragment_virial_params
  use numbers
  real(kind=doubleR)::f_m,f_rm,f_a,f_s,f_ra,espo,limit_var
end module fragment_virial_params

module fragment_run_flags
  use numbers
end module fragment_run_flags


#ifdef PLC
module tocompute_PLC_condition
  use numbers
  integer(kind=singleI)::thisgroup,replicate(3)
!  real(kind=doubleR)::dist_at_F
end module tocompute_PLC_condition
#endif


module tocompute_pos
  use numbers
  type unit_obj
     sequence
     integer(kind=singleI)::M,i
     real(kind=doubleR)::q(3),v(3),F
  end type unit_obj
  type(unit_obj)::obj,obj1,obj2
end module tocompute_pos


