!*****************************************************************
!*                       PINOCCHI0  V3.0                         *
!*  (PINpointing Orbit-Crossing Collapsed HIerarchical Objects)  *
!*****************************************************************
!
!This code was written by
!Pierluigi Monaco, Tom Theuns, Giuliano Taffoni
!Copyright (C) 2013
!
!web page: http//adlibitum.oats.inaf.it/monaco/Homepage/Pinocchio/
!
!This program is free software; you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation; either version 2 of the License, or
!(at your option) any later version.
!
!This program is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with this program; if not, write to the Free Software
!Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

program pinocchio

  use pinocchio_module
  implicit none
  character(len=24), external :: fdate

! **************************************************
!                   STARTING MPI
! **************************************************

  call MPI_INIT(ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, proc_id, ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nproc, ierr)

! timing of the code
  cputime(0) = MPI_WTIME()

  call message("This is pinocchio 3.0")

  write(info,'("[",a24,"] Starting run, # processors = ",i6)') fdate(), nproc
  call message (trim(info))

! computation of collapse times
  call fmax()

  if (DoNotFragment) then
     call MPI_BARRIER(MPI_COMM_WORLD, ierr)
     call finish('Pinocchio done!')
  endif

! fragmentation
  call fragment()

! output detailed cpu times
  call MPI_BARRIER(MPI_COMM_WORLD, ierr)
  cputime(0)=MPI_WTIME()-cputime(0)
  if (proc_id==0) call write_cputimes()

! finalize MPI
  call finish('Pinocchio done!')

end program pinocchio
